function y=forcing_interaction_H(h1_H_full,h3_a1,B,N,m,l,p,...
    m_forcing,l_forcing,p_forcing,psil,psip,k_1)

k=norm(k_1);

factor=-(B/2)*m_forcing*k;
temp_sum=0+0i;
for r_i=1:length(h1_H_full)
    r_wn=r_i-(N);
    n_wn=-r_wn-m;
    n_i=n_wn+(N);
    if n_i<2*N && n_i>0
        temp_sum=temp_sum+h1_H_full(r_i)*h3_a1(n_i);
    end
end
C1=factor*temp_sum;

temp_sum=0+0i;
for r_i=1:length(h1_H_full)
    r_wn=r_i-(N);
    n_wn=-r_wn+m;
    n_i=n_wn+(N);
    if n_i<2*N && n_i>0
        temp_sum=temp_sum+h1_H_full(r_i)*h3_a1(n_i);
    end
end
C2=factor*temp_sum;

factor=-(B/2)*l_forcing*exp(1i*psil)*k;
temp_sum=0+0i;
for r_i=1:length(h1_H_full)
    r_wn=r_i-(N);
    n_wn=-r_wn-l;
    n_i=n_wn+(N);
    if n_i<2*N && n_i>0
        temp_sum=temp_sum+h1_H_full(r_i)*h3_a1(n_i);
    end
end
C3=factor*temp_sum;

factor=-(B/2)*l_forcing*exp(-1i*psil)*k;
temp_sum=0+0i;
for r_i=1:length(h1_H_full)
    r_wn=r_i-(N);
    n_wn=-r_wn+l;
    n_i=n_wn+(N);
    if n_i<2*N && n_i>0
        temp_sum=temp_sum+h1_H_full(r_i)*h3_a1(n_i);
    end
end
C4=factor*temp_sum;

factor=-(B/2)*p_forcing*exp(1i*psip)*k;
temp_sum=0+0i;
for r_i=1:length(h1_H_full)
    r_wn=r_i-(N);
    n_wn=-r_wn-p;
    n_i=n_wn+(N);
    if n_i<2*N && n_i>0
        temp_sum=temp_sum+h1_H_full(r_i)*h3_a1(n_i);
    end
end
C5=factor*temp_sum;

factor=-(B/2)*p_forcing*exp(-1i*psip)*k;
temp_sum=0+0i;
for r_i=1:length(h1_H_full)
    r_wn=r_i-(N);
    n_wn=-r_wn+p;
    n_i=n_wn+(N);
    if n_i<2*N && n_i>0
        temp_sum=temp_sum+h1_H_full(r_i)*h3_a1(n_i);
    end
end
C6=factor*temp_sum;

y=C1+C2+C3+C4+C5+C6;