function y=general_wn_interaction_H(K,h1_H_full,p1_H_full,...
    Hp,Hm,Pp,Pm,h3_a1,N,epsilon_2,C)
%integrate H
y=zeros(length(K(1,:)),(length(K(1,:))-1));
wnc=length(K(1,:));
% |A_j|^2A_u (self-interaction) for j=!u
for i=1:length(K(1,:))
    ku=K(:,i);
    kj=K;
    kj(:,i)=[];
    hp=Hp;
    hp(:,wnc-(i-1))=[];
    hm=Hm;
    hm(:,wnc-(i-1))=[];
    pp=Pp;
    pp(:,wnc-(i-1))=[];
    pm=Pm;
    pm(:,wnc-(i-1))=[];
    % full_H(put_together(solve_second_order_k1pk2_SH(p1_SH,h1_SH,B,C,epsilon_2,k1,-k2,y2(1,1),psi,m,l,m_forcing,l_forcing)));

    for j=1:length(kj(1,:))
    temp_sum=0;
    for r_i=1:2*N-1
        r_wn=r_i-(N);
        for s_i=1:2*N-1
            s_wn=s_i-N;
            n_wn=-s_wn-r_wn;
            n_i=n_wn+(N);
            if n_i<2*N && n_i>0
                temp_sum=temp_sum+...
                -(1i*(r_wn+s_wn)+2*epsilon_2*norm(ku)^2)*...
                (-2*dot(ku+kj(:,j),ku)*pp(s_i,j)-...
                2*dot(ku-kj(:,j),ku)*pm(s_i,j))*...
                h1_H_full(r_i)*h3_a1(n_i);
            end
        end
    end
    B11=temp_sum;%CHECKED
    
    temp_sum=0;
    for r_i=1:2*N-1
        r_wn=r_i-(N);
        for s_i=1:2*N-1
            s_wn=s_i-N;
            n_wn=-s_wn-r_wn;
            n_i=n_wn+(N);
            if n_i<2*N && n_i>0
                temp_sum=temp_sum+...
                -(1i*(r_wn+s_wn)+2*epsilon_2*norm(ku)^2)*...
                (2*dot(kj(:,j),ku)*hp(s_i,j)-2*dot(kj(:,j),ku)*hm(s_i,j))*...
                p1_H_full(r_i)*h3_a1(n_i);
            end
        end
    end
    B12=temp_sum;%CHECKED
    
    temp_sum=0;
    for r_i=1:2*N-1
        r_wn=r_i-(N);
        for s_i=1:2*N-1
            s_wn=s_i-N;
            n_wn=-s_wn-r_wn;
            n_i=n_wn+(N);
            if n_i<2*N && n_i>0
                temp_sum=temp_sum+...
                -(1i*(r_wn+s_wn)+2*epsilon_2*norm(ku)^2)*...
                (2*norm(ku+kj(:,j))*norm(ku)*pp(s_i,j)+...
                2*norm(ku-kj(:,j))*norm(ku)*pm(s_i,j))*...
                h1_H_full(r_i)*h3_a1(n_i);
            end
        end
    end
    B13=temp_sum;%CHECKED
    
    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:2*N-1
            s_wn=s_i-N;
            n_wn=-s_wn-r_wn;
            n_i=n_wn+(N);
            if n_i<2*N && n_i>0
                temp_sum=temp_sum+...
                -(1i*(r_wn+s_wn)+2*epsilon_2*norm(ku)^2)*...
                (2*norm(kj(:,j))*norm(ku)*hp(s_i,j)+...
                2*norm(kj(:,j))*norm(ku)*hm(s_i,j))*...
                p1_H_full(r_i)*h3_a1(n_i);
            end
        end
    end
    B14=temp_sum;%CHECKED
    
    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h1_H_full)
            s_wn=s_i-(N);
            for t_i=1:length(h1_H_full)
                t_wn=t_i-(N);
                n_wn=-t_wn-s_wn-r_wn;
                n_i=n_wn+(N);
                if n_i<2*N && n_i>0
                    temp_sum=temp_sum+...
                    (1i*(r_wn+s_wn+t_wn)+2*epsilon_2*norm(ku)^2)*...
                    (norm(kj(:,j))*norm(ku-kj(:,j))*norm(ku)+...
                    norm(ku)*norm(ku-kj(:,j))*norm(ku)+...
                    norm(ku)*norm(ku+kj(:,j))*norm(ku)+...
                    norm(kj(:,j))*norm(ku+kj(:,j))*norm(ku))*...
                    h1_H_full(r_i)*h1_H_full(s_i)*p1_H_full(t_i)*h3_a1(n_i);
                end
            end
        end
    end
    B15=temp_sum;%CHECKED
    
    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h1_H_full)
            s_wn=s_i-(N);
            for t_i=1:length(h1_H_full)
                t_wn=t_i-(N);
                n_wn=-t_wn-s_wn-r_wn;
                n_i=n_wn+(N);
                if n_i<2*N && n_i>0
                    temp_sum=temp_sum+...
                    -0.5*(1i*(r_wn+s_wn+t_wn)+2*epsilon_2*norm(ku)^2)*...
                    (2*(norm(ku)^3+2*norm(kj(:,j))^2*norm(ku)))*...
                    h1_H_full(r_i)*h1_H_full(s_i)*p1_H_full(t_i)*h3_a1(n_i);
                end
            end
        end
    end
    B16=temp_sum;%CHECKED
    
    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h1_H_full)
            s_wn=s_i-(N);
            for t_i=1:length(h1_H_full)
                t_wn=t_i-(N);
                n_wn=-t_wn-s_wn-r_wn;
                n_i=n_wn+(N);
                if n_i<2*N && n_i>0
                    temp_sum=temp_sum+...
                    -0.5*(1i*(r_wn+s_wn+t_wn)+2*epsilon_2*norm(ku)^2)*...
                    (2*(norm(ku)^3+2*norm(kj(:,j))*norm(ku)^2))*...
                    h1_H_full(r_i)*h1_H_full(s_i)*p1_H_full(t_i)*h3_a1(n_i);
                end
            end
        end
    end
    B17=temp_sum;%CHECKED
    
    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:2*N-1
            s_wn=s_i-N;
            n_wn=-s_wn-r_wn;
            n_i=n_wn+(N);
            if n_i<2*N && n_i>0
                temp_sum=temp_sum+...
                (2*norm(kj(:,j))*norm(ku+kj(:,j))*pp(s_i,j)+...
                2*norm(ku-kj(:,j))*norm(kj(:,j))*pm(s_i,j))*...
                p1_H_full(r_i)*h3_a1(n_i);
            end
        end
    end
    B21=temp_sum*norm(ku);%CHECKED
    
    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:2*N-1
            s_wn=s_i-N;
            n_wn=-s_wn-r_wn;
            n_i=n_wn+(N);
            if n_i<2*N && n_i>0
                temp_sum=temp_sum+...
                (-2*dot(kj(:,j),ku+kj(:,j))*pp(s_i,j)+...
                2*dot(ku-kj(:,j),kj(:,j))*pm(s_i,j))*...
                p1_H_full(r_i)*h3_a1(n_i);
            end
        end
    end
    B22=temp_sum*norm(ku);%CHECKED
    
    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h1_H_full)
            s_wn=s_i-(N);
            for t_i=1:length(h1_H_full)
                t_wn=t_i-(N);
                n_wn=-t_wn-s_wn-r_wn;
                n_i=n_wn+(N);
                if n_i<2*N && n_i>0
                    temp_sum=temp_sum+...
                    2*(norm(kj(:,j))^3+...
                    norm(ku)*norm(kj(:,j))^2+...
                    norm(kj(:,j))*norm(ku)^2)*...
                    h1_H_full(r_i)*p1_H_full(s_i)*p1_H_full(t_i)*h3_a1(n_i);
                end
            end
        end
    end
    B23=temp_sum*norm(ku);%CHECKED

    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h1_H_full)
            s_wn=s_i-(N);
            for t_i=1:length(h1_H_full)
                t_wn=t_i-(N);
                n_wn=-t_wn-s_wn-r_wn;
                n_i=n_wn+(N);
                if n_i<2*N && n_i>0
                    temp_sum=temp_sum-...% Mistake - this should have a minus
                    (norm(kj(:,j))*norm(ku+kj(:,j))*(norm(ku)+norm(kj(:,j)))...
                    +norm(kj(:,j))*norm(ku-kj(:,j))*(norm(ku)+norm(kj(:,j))))*...
                    h1_H_full(r_i)*p1_H_full(s_i)*p1_H_full(t_i)*h3_a1(n_i);
                end
            end
        end
    end
    B24=temp_sum*norm(ku);%CHECKED
    
    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h1_H_full)
            s_wn=s_i-(N);
            for t_i=1:length(h1_H_full)
                t_wn=t_i-(N);
                n_wn=-t_wn-s_wn-r_wn;
                n_i=n_wn+(N);
                if n_i<2*N && n_i>0
                    temp_sum=temp_sum+...
                    (C)*(2*dot(ku,kj(:,j))^2+norm(kj(:,j))^2*norm(ku)^2)*...
                    h1_H_full(r_i)*h1_H_full(s_i)*h1_H_full(t_i)*h3_a1(n_i);
                end
            end
        end
    end
    B25=temp_sum*norm(ku);%CHECKED
    
    y(i,j)=(B11+B12+B13+B14+B15+B16+B17+B21+B22+B23+B24+B25);
    end
end

end


