function y=make_p1_second_order_keq1_H(h2_k1pk2,hm,pm,epsilon_2,solve_ord2,k_1)

y=zeros(length(h2_k1pk2),1); % because SH
p=full_H(pm);
h=full_H(hm);
N=length(h2_k1pk2);
k=norm(k_1);
for i=1:length(h2_k1pk2)
   n_count=i-1;
   y(i,1)=(1i*(n_count)+2*epsilon_2*k^2)*h2_k1pk2(i,1)/k+...
       0.5*solve_ord2*hm(i,1)/k;
   
   % rhs
    rhs_temp=0+0*1i;
    for r=1:length(p) % index of pl %CHECKED
        r_wn=r-(N); % corresponding wavenumber %CHECKED
        s_wn=n_count-r_wn; %'paired' wavenumber %CHECKED
        s=s_wn+(N); % corresponding index %CHECKED
        if s<2*N && s>0
        rhs_temp=rhs_temp+...
            k*h(r,1)*p(s,1);
        end
    end
    y(i,1)=y(i,1)+0.5*rhs_temp; % needs 0.5 factor for double counting
    
end

end%CHECKED