% fully checked, final version, DO NOT CHANGE
function y=filter_3_2d(f_u)
% get lengths from input
N_x=length(f_u(1,:));
N_y=length(f_u(:,1));
% fft
Y=fft2(f_u);
% select mode to start suppressing based on order of nonlinearity
stop_mode_x=floor((N_x-1)/4)+2; % INDEX of the mode to stop in x
stop_mode_y=floor((N_y-1)/4)+2; % INDEX of the mode to stop in y
% eliminate problem modes in x
for i_x=stop_mode_x:(N_x-(stop_mode_x-2))
    Y(:,i_x)=zeros(N_y,1);
end
% do same in y modes
for i_y=stop_mode_y:(N_y-(stop_mode_y-2))
    Y(i_y,:)=zeros(1,N_x);
end
y=ifft2(Y);
end