% for a sin forcing with SH response!
function y=find_a_min(k,omega,nu,g_0,gamma,rho)
N=40;
A=zeros(2*N,2*N);
B=A;
nu_factor=0;
    B(1,1:6)=[0,1,0,1,0,0]; % DC
    B(2,1:6)=[1,0,-1,0,0,0]; % DC
    E_A=(-omega^2*(0.5)^2+4*nu*1i*k^2*omega*(0.5)+nu_factor*4*nu^2*k^4)/k+...
        (g_0+gamma*k^2/rho); % DC
    A(1,1)=real(E_A); A(1,2)=-imag(E_A);
    A(2,1)=imag(E_A); A(2,2)=real(E_A); %DC
    n_count=1;
    for n=3:2:2*N-3 %DC
        % make matrix A
        E_A=(-omega^2*(n_count+0.5)^2+4*nu*1i*k^2*omega*(n_count+0.5)...
            +nu_factor*4*nu^2*k^4)/k+(g_0+gamma*k^2/rho);%DC
        A(n,n)=real(E_A); A(n,n+1)=-imag(E_A);
        A(n+1,n)=imag(E_A); A(n+1,n+1)=real(E_A);%DC
        
        % make matrix B
        B(n,n-2:n+3)=[0,-1,0,0,0,1]; %DC
        B(n+1,n-2:n+3)=[1,0,0,0,-1,0]; %DC
        n_count=n_count+1;
    end
    for n=2*N-1
        % N-0.5 because n=19 when truncating at N=20
        E_A=(-omega^2*(N-0.5)^2+4*nu*1i*k^2*omega*(N-0.5)...
            +nu_factor*4*nu^2*k^4)/k+(g_0+gamma*k^2/rho);%DC
        A(n,n)=real(E_A); A(n,n+1)=-imag(E_A);
        A(n+1,n)=imag(E_A); A(n+1,n+1)=real(E_A);%DC
        
        B(n,n-2:end)=[0,-1,0,0]; B(n+1,n-2:end)=[1,0,0,0];
    end
    
    [P,D]=eig(((2/g_0).*A)\B);
    
    J=diag(D);%CHECKED
    p_count=1;%CHECKED
    for I=1:length(J)%CHECKED
        if abs(imag(J(I,1)))<1e-9%CHECKED
            J_2(p_count)=real(J(I,1));%CHECKED
            p_count=p_count+1;%CHECKED
        end
    end
    J_3=max((J_2));%CHECKED
    y=1/J_3;%CHECKED  
end