% fully checked, final version, DO NOT CHANGE
function y=nonlinear_part_2d(f_u,x_l,y_l,f_C)
% get space domain solution from input
h=ifft2(f_u(:,:,1));
phi=ifft2(f_u(:,:,2));
% dno on phi
D_phi=dno(phi,x_l,y_l);
% dno(hdno(phi))
D_h_D_phi=dno(h.*D_phi,x_l,y_l);
% dno(hdno(hdno(phi)))
D_h_D_h_D_phi=dno(h.*D_h_D_phi,x_l,y_l);
% calculate h^2
h_2=h.^2;
% laplacian phi
dxxyy_phi=partial_xx(phi,x_l)+partial_yy(phi,y_l);
% partial derivatives of variables
dx_h=partial_x(h,x_l);
dy_h=partial_y(h,y_l);
dx_phi=partial_x(phi,x_l);
dy_phi=partial_y(phi,y_l);
% find nonlinear part in space domain
% for h equation
y(:,:,1)=-partial_x(h.*dx_phi,x_l)-partial_y(h.*dy_phi,y_l)...
    +0.5*(partial_xx(h_2.*D_phi,x_l)+partial_yy(h_2.*D_phi,y_l))...
    -D_h_D_phi...
    +D_h_D_h_D_phi...
    +0.5*dno(h_2.*dxxyy_phi,x_l,y_l);
% for phi equation
y(:,:,2)=0.5*(D_phi.^2)...
    -0.5*((dx_phi).^2+(dy_phi).^2)...
    -D_phi.*(h.*dxxyy_phi+D_h_D_phi)...
    -0.5*f_C*(partial_x((dx_h.^2+dy_h.^2).*dx_h,x_l)...
    +partial_y((dx_h.^2+dy_h.^2).*dy_h,y_l));
end