function y=partial_y(f_u,l_y)
% get lengths from input
length_x=length(f_u(1,:));
length_y=length(f_u(:,1));
% fft
YY=fft2(f_u);
% setup y mode wavenumbers
K_y=zeros(1,length_y);
K_y(2:length_y/2)=(2*pi/l_y)*[1:length_y/2-1];
K_y(length_y/2+2:end)=-fliplr(K_y(2:length_y/2));
%perform differential
for i_x=1:length_x/2
    for i_y=1:length_y
        YY(i_y,i_x)=1i*K_y(i_y)*YY(i_y,i_x);
    end
end
% reset wavenumber to half in y mode
i_y=length_y/2;
% use symmetry to determine other modes
YY(1,i_x+2:end)=fliplr(conj(YY(1,2:i_x)));
YY(i_y+1,:)=zeros(1,length_x);% eliminate nyquist
YY(:,i_x+1)=zeros(length_y,1);% eliminate nyquist
% other modes
YY(i_y+2:end,i_x+2:end)=rot90(conj(YY(2:i_y,2:i_x)),2);
YY(2:i_y,i_x+2:end)=rot90(conj(YY(i_y+2:end,2:i_x)),2);
y=ifft2(YY);
end