function y=forcing_interaction_SH(h1_SH_full,h3_a1,B,N,m,l,p,m_forcing,l_forcing,p_forcing,psil,psip,a_0)

factor=-(B*a_0/2)*m_forcing;
temp_sum=0+0i;
for r_i=1:length(h1_SH_full)
    r_wn=r_i-(N+1);
    n_wn=-1-r_wn-m;
    n_i=n_wn+(N+1);
    if n_i<2*N+1 && n_i>0
        temp_sum=temp_sum+h1_SH_full(r_i)*h3_a1(n_i);
    end
end
C1=factor*temp_sum;

temp_sum=0+0i;
for r_i=1:length(h1_SH_full)
    r_wn=r_i-(N+1);
    n_wn=-1-r_wn+m;
    n_i=n_wn+(N+1);
    if n_i<2*N+1 && n_i>0
        temp_sum=temp_sum+h1_SH_full(r_i)*h3_a1(n_i);
    end
end
C2=factor*temp_sum;

factor=-(B*a_0/2)*l_forcing*exp(1i*psil);
temp_sum=0+0i;
for r_i=1:length(h1_SH_full)
    r_wn=r_i-(N+1);
    n_wn=-1-r_wn-l;
    n_i=n_wn+(N+1);
    if n_i<2*N+1 && n_i>0
        temp_sum=temp_sum+h1_SH_full(r_i)*h3_a1(n_i);
    end
end
C3=factor*temp_sum;

factor=-(B*a_0/2)*l_forcing*exp(-1i*psil);
temp_sum=0+0i;
for r_i=1:length(h1_SH_full)
    r_wn=r_i-(N+1);
    n_wn=-1-r_wn+l;
    n_i=n_wn+(N+1);
    if n_i<2*N+1 && n_i>0
        temp_sum=temp_sum+h1_SH_full(r_i)*h3_a1(n_i);
    end
end
C4=factor*temp_sum;

factor=-(B*a_0/2)*p_forcing*exp(1i*psip);
temp_sum=0+0i;
for r_i=1:length(h1_SH_full)
    r_wn=r_i-(N+1);
    n_wn=-1-r_wn-p;
    n_i=n_wn+(N+1);
    if n_i<2*N+1 && n_i>0
        temp_sum=temp_sum+h1_SH_full(r_i)*h3_a1(n_i);
    end
end
C5=factor*temp_sum;

factor=-(B*a_0/2)*p_forcing*exp(-1i*psip);
temp_sum=0+0i;
for r_i=1:length(h1_SH_full)
    r_wn=r_i-(N+1);
    n_wn=-1-r_wn+p;
    n_i=n_wn+(N+1);
    if n_i<2*N+1 && n_i>0
        temp_sum=temp_sum+h1_SH_full(r_i)*h3_a1(n_i);
    end
end
C6=factor*temp_sum;

y=C1+C2+C3+C4+C5+C6;