function y=self_interaction_H(h1_H_full,p1_H_full,h2_k1pk1_H_full,...
    h3_a1,N,epsilon_2,C,k1)
% |A_u|^2A_u (self-interaction)
ku=norm(k1);
temp_sum=0;
    for r_i=1:length(p1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h2_k1pk1_H_full)
            s_wn=s_i-N;
            n_wn=-s_wn-r_wn;
            n_i=n_wn+(N);
            if n_i<2*N && n_i>0
                temp_sum=temp_sum+...
                -2*(1i*(r_wn+s_wn)+2*epsilon_2*norm(ku)^2)*...
                p1_H_full(r_i)*(h2_k1pk1_H_full(s_i))*h3_a1(n_i);
            end
        end
    end
    A21=temp_sum*norm(ku)^2;%CHECKED

    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h1_H_full)
            s_wn=s_i-(N);
            for t_i=1:length(h1_H_full)
                t_wn=t_i-(N);
                n_wn=-t_wn-s_wn-r_wn;
                n_i=n_wn+(N);
                if n_i<2*N && n_i>0
                    temp_sum=temp_sum+...
                    -(1i*(r_wn+s_wn+t_wn)+2*epsilon_2*norm(ku)^2)*...
                    h1_H_full(r_i)*h1_H_full(s_i)*p1_H_full(t_i)*h3_a1(n_i);
                end
            end
        end
    end
    A22=temp_sum*norm(ku)^3;%CHECKED

    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h1_H_full)
            s_wn=s_i-(N);
            for t_i=1:length(h1_H_full)
                t_wn=t_i-(N);
                n_wn=-t_wn-s_wn-r_wn;
                n_i=n_wn+(N);
                if n_i<2*N && n_i>0
                    temp_sum=temp_sum+...
                    h1_H_full(r_i)*p1_H_full(s_i)*p1_H_full(t_i)*h3_a1(n_i);
                end
            end
        end
    end
    A23=temp_sum*norm(ku)^4;%CHECKED

    temp_sum=0;
    for r_i=1:length(h1_H_full)
        r_wn=r_i-(N);
        for s_i=1:length(h1_H_full)
            s_wn=s_i-(N);
            for t_i=1:length(h1_H_full)
                t_wn=t_i-(N);
                n_wn=-t_wn-s_wn-r_wn;
                n_i=n_wn+(N);
                if n_i<2*N && n_i>0
                    temp_sum=temp_sum+...
                    (3*C/2)*h1_H_full(r_i)*h1_H_full(s_i)*h1_H_full(t_i)*h3_a1(n_i);
                end
            end
        end
 
    A24=temp_sum*norm(ku)^5;%CHECKED
    end

    y=(A21+A22+A23+A24);