function y=partial_x(f_u,l_x)
% get lengths from input
length_x=length(f_u(1,:));
length_y=length(f_u(:,1));
% fft
YY=fft2(f_u);
% set up wavenumbers in x
K_x=zeros(1,length_x);
K_x(2:length_x/2)=(2*pi/l_x)*[1:length_x/2-1];
K_x(length_x/2+2:end)=-fliplr(K_x(2:length_x/2));
% perform differential
for i_y=1:length_y/2
    for i_x=1:length_x
        YY(i_y,i_x)=1i*K_x(i_x)*YY(i_y,i_x);
    end
end
% reset x mode index to halfway
i_x=length_x/2;
% use symmetry of 2d fft to derive rest of solution
YY(i_y+2:end,1)=flipud(conj(YY(2:i_y,1)));
YY(i_y+1,:)=zeros(1,length_x); % remove nyquist
YY(:,i_x+1)=zeros(length_y,1);% remove nyquist
% other modes
YY(i_y+2:end,i_x+2:end)=rot90(conj(YY(2:i_y,2:i_x)),2);
YY(i_y+2:end,2:i_x)=rot90(conj(YY(2:i_y,i_x+2:end)),2);
y=ifft2(YY);
end